import { __extends } from 'tslib';
import { DataSource } from '@angular/cdk/collections';
import { catchError, finalize, debounceTime, distinctUntilChanged, tap } from 'rxjs/operators';
import { BehaviorSubject, of, merge, fromEvent } from 'rxjs';
import { coerceBooleanProperty } from '@angular/cdk/coercion';
import { noop, throttle } from 'lodash-es';
import { CommonModule } from '@angular/common';
import { A11yModule } from '@angular/cdk/a11y';
import { DragDropModule } from '@angular/cdk/drag-drop';
import { PortalModule } from '@angular/cdk/portal';
import { ScrollingModule } from '@angular/cdk/scrolling';
import { CdkStepperModule } from '@angular/cdk/stepper';
import { CdkTableModule } from '@angular/cdk/table';
import { CdkTreeModule } from '@angular/cdk/tree';
import { MatAutocompleteModule } from '@angular/material/autocomplete';
import { MatBadgeModule } from '@angular/material/badge';
import { MatBottomSheetModule } from '@angular/material/bottom-sheet';
import { MatButtonModule } from '@angular/material/button';
import { MatButtonToggleModule } from '@angular/material/button-toggle';
import { MatCardModule } from '@angular/material/card';
import { MatCheckboxModule } from '@angular/material/checkbox';
import { MatChipsModule } from '@angular/material/chips';
import { MatStepperModule } from '@angular/material/stepper';
import { MatDatepickerModule } from '@angular/material/datepicker';
import { MatDialogModule } from '@angular/material/dialog';
import { MatDividerModule } from '@angular/material/divider';
import { MatExpansionModule } from '@angular/material/expansion';
import { MatPaginator, MatSort, MatTable, MatTableDataSource, MatSortHeader, MatColumnDef, MatFormFieldModule } from '@angular/material';
import { MatGridListModule } from '@angular/material/grid-list';
import { MatIconModule } from '@angular/material/icon';
import { MatInputModule } from '@angular/material/input';
import { MatListModule } from '@angular/material/list';
import { MatMenuModule } from '@angular/material/menu';
import { MatNativeDateModule, MatRippleModule } from '@angular/material/core';
import { MatPaginatorModule } from '@angular/material/paginator';
import { MatProgressBarModule } from '@angular/material/progress-bar';
import { MatProgressSpinnerModule } from '@angular/material/progress-spinner';
import { MatRadioModule } from '@angular/material/radio';
import { MatSelectModule } from '@angular/material/select';
import { MatSidenavModule } from '@angular/material/sidenav';
import { MatSliderModule } from '@angular/material/slider';
import { MatSlideToggleModule } from '@angular/material/slide-toggle';
import { MatSnackBarModule } from '@angular/material/snack-bar';
import { MatSortModule } from '@angular/material/sort';
import { MatTableModule } from '@angular/material/table';
import { MatTabsModule } from '@angular/material/tabs';
import { MatToolbarModule } from '@angular/material/toolbar';
import { MatTooltipModule } from '@angular/material/tooltip';
import { MatTreeModule } from '@angular/material/tree';
import { HttpClient, HttpParams, HttpClientModule } from '@angular/common/http';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
import { NgbActiveModal, NgbModal, NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { Injectable, NgModule, Component, Input, Output, EventEmitter, HostListener, ElementRef, ViewChild, defineInjectable, inject, Optional } from '@angular/core';

var PortalsdkTagLibService = /** @class */ (function () {
    function PortalsdkTagLibService() {
    }
    PortalsdkTagLibService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    PortalsdkTagLibService.ctorParameters = function () { return []; };
    PortalsdkTagLibService.ngInjectableDef = defineInjectable({ factory: function PortalsdkTagLibService_Factory() { return new PortalsdkTagLibService(); }, token: PortalsdkTagLibService, providedIn: "root" });
    return PortalsdkTagLibService;
}());

var PortalsdkTagLibComponent = /** @class */ (function () {
    function PortalsdkTagLibComponent() {
    }
    PortalsdkTagLibComponent.prototype.ngOnInit = function () {
    };
    PortalsdkTagLibComponent.decorators = [
        { type: Component, args: [{
                    selector: 'enl-portalsdk-tag-lib',
                    template: "\n    <p>\n      portalsdk-tag-lib works!\n    </p>\n  "
                }] }
    ];
    /** @nocollapse */
    PortalsdkTagLibComponent.ctorParameters = function () { return []; };
    return PortalsdkTagLibComponent;
}());

var PortalsdkTagLibModule = /** @class */ (function () {
    function PortalsdkTagLibModule() {
    }
    PortalsdkTagLibModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [PortalsdkTagLibComponent],
                    imports: [],
                    exports: [PortalsdkTagLibComponent]
                },] }
    ];
    return PortalsdkTagLibModule;
}());

var RdpDataTableService = /** @class */ (function () {
    function RdpDataTableService(http) {
        this.http = http;
    }
    RdpDataTableService.prototype.add = function (applicationService, data) {
        applicationService.add(data);
    };
    RdpDataTableService.prototype.update = function (applicationService, data) {
        applicationService.update(data);
    };
    RdpDataTableService.prototype.delete = function (applicationService, data) {
        applicationService.delete(data);
    };
    RdpDataTableService.prototype.get = function (applicationService, data) {
        applicationService.get(data);
    };
    RdpDataTableService.prototype.getTableDataList = function (pageIndex, pageSize, serviceUrl) {
        return this.http.get(serviceUrl, {
            params: new HttpParams()
                .set('pageIndex', pageIndex.toString())
                .set('pageSize', pageSize.toString())
        });
    };
    RdpDataTableService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    RdpDataTableService.ctorParameters = function () { return [
        { type: HttpClient }
    ]; };
    RdpDataTableService.ngInjectableDef = defineInjectable({ factory: function RdpDataTableService_Factory() { return new RdpDataTableService(inject(HttpClient)); }, token: RdpDataTableService, providedIn: "root" });
    return RdpDataTableService;
}());

var RdpDataTableEditComponent = /** @class */ (function () {
    function RdpDataTableEditComponent(activeModal, rdpDataTableService) {
        this.activeModal = activeModal;
        this.rdpDataTableService = rdpDataTableService;
        this.passEntry = new EventEmitter();
        this.columnsInfoList = [];
    }
    RdpDataTableEditComponent.prototype.ngOnInit = function () {
        this.modalPopupTitle = "Edit";
        if (this.rowdata) {
            this.selectedRowData = JSON.stringify(this.rowdata);
        }
        if (this.settings) {
            if (this.settings.modalPopupTitle) {
                this.modalPopupTitle = this.settings.modalPopupTitle;
            }
            for (var index in this.settings.columns) {
                this.columnsInfoList.push(this.settings.columns[index]);
            }
        }
    };
    RdpDataTableEditComponent.prototype.saveChanges = function () {
        this.passEntry.emit(this.rowdata);
        this.activeModal.close();
    };
    RdpDataTableEditComponent.prototype.columnDataChanged = function ($event, columnTitle) {
        this.rowdata[columnTitle] = $event;
    };
    RdpDataTableEditComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-rdp-data-table-edit',
                    template: "<!--\r\n  ============LICENSE_START==========================================\r\n  ONAP Portal- SDK\r\n  ===================================================================\r\n  Copyright (C) 2019 AT&T Intellectual Property. All rights reserved.\r\n  ===================================================================\r\n \r\n  Unless otherwise specified, all software contained herein is licensed\r\n  under the Apache License, Version 2.0 (the \"License\");\r\n  you may not use this software except in compliance with the License.\r\n  You may obtain a copy of the License at\r\n \r\n              http://www.apache.org/licenses/LICENSE-2.0\r\n \r\n  Unless required by applicable law or agreed to in writing, software\r\n  distributed under the License is distributed on an \"AS IS\" BASIS,\r\n  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\r\n  See the License for the specific language governing permissions and\r\n  limitations under the License.\r\n \r\n  Unless otherwise specified, all documentation contained herein is licensed\r\n  under the Creative Commons License, Attribution 4.0 Intl. (the \"License\");\r\n  you may not use this documentation except in compliance with the License.\r\n  You may obtain a copy of the License at\r\n \r\n              https://creativecommons.org/licenses/by/4.0/\r\n \r\n  Unless required by applicable law or agreed to in writing, documentation\r\n  distributed under the License is distributed on an \"AS IS\" BASIS,\r\n  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\r\n  See the License for the specific language governing permissions and\r\n  limitations under the License.\r\n \r\n  ============LICENSE_END============================================\r\n\r\n  -->\r\n\r\n  <div class=\"container\">\r\n    <div class=\"modal-header\">\r\n      <h4 class=\"modal-title\">{{modalPopupTitle}}</h4>\r\n      <button type=\"button\" class=\"close\" aria-label=\"Close\" (click)=\"activeModal.dismiss('Cross')\">\r\n        <span aria-hidden=\"true\">&times;</span>\r\n      </button>\r\n    </div>\r\n  \r\n    <div class=\"modal-body\">\r\n      <!-- This is the modal body where fields has to apper with respect to their field type -->\r\n      <div *ngFor=\"let column of columnsInfoList\">\r\n          {{column.dispalyTitle | titlecase}}\r\n          <div [ngSwitch]=\"column.type\">\r\n            <div *ngSwitchCase=\"'text'\">\r\n              <rdp-input-editor (changedColumnValue)=\"columnDataChanged($event, column.title)\" \r\n                rowdata=\"{{selectedRowData}}\" \r\n                columntitle=\"{{column.title}}\" \r\n                disabled=\"{{column.isColumnDisabled}}\"\r\n              >\r\n              </rdp-input-editor>\r\n            </div>\r\n            <div *ngSwitchCase=\"'dropdown'\">\r\n              <rdp-select-editor (changedColumnValue)=\"columnDataChanged($event, column.title)\"\r\n               rowdata=\"{{selectedRowData}}\" \r\n               [data]=\"column.listData\" \r\n               columntitle=\"{{column.title}}\"></rdp-select-editor>\r\n            </div> \r\n            <div *ngSwitchCase=\"'textarea'\">\r\n              <rdp-textarea-editor rowdata=\"{{selectedRowData}}\" columntitle=\"{{column.title}}\"></rdp-textarea-editor>\r\n            </div> \r\n            <div *ngSwitchCase=\"'checkbox'\">\r\n              <rdp-checkbox-editor rowdata=\"{{selectedRowData}}\" columntitle=\"{{column.title}}\"></rdp-checkbox-editor>\r\n            </div> \r\n            <div *ngSwitchCase=\"'radio'\">\r\n              <rdp-radio-editor rowdata=\"{{selectedRowData}}\" columntitle=\"{{column.title}}\"></rdp-radio-editor>\r\n            </div>\r\n            <div *ngSwitchCase=\"'datepicker'\">\r\n              <rdp-datepicker-editor rowdata=\"{{selectedRowData}}\" columntitle=\"{{column.title}}\"></rdp-datepicker-editor>\r\n            </div>\r\n            <div *ngSwitchDefault>\r\n                <rdp-input-editor (changedColumnValue)=\"columnDataChanged($event, column.title)\" \r\n                rowdata=\"{{selectedRowData}}\" columntitle=\"{{column.title}}\"></rdp-input-editor>\r\n            </div>      \r\n          </div>\r\n      </div>\r\n    </div>\r\n  \r\n    <div class=\"modal-footer\">\r\n      <button type=\"button\" class=\"btn btn-primary\" (click)=\"saveChanges()\">Save</button> &nbsp;\r\n      <button type=\"button\" class=\"btn btn-primary\" (click)=\"activeModal.close('Close')\">Cancel</button>\r\n    </div>\r\n  </div>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    RdpDataTableEditComponent.ctorParameters = function () { return [
        { type: NgbActiveModal },
        { type: RdpDataTableService }
    ]; };
    RdpDataTableEditComponent.propDecorators = {
        settings: [{ type: Input }],
        rowdata: [{ type: Input }],
        isEditMode: [{ type: Input }],
        passEntry: [{ type: Output }]
    };
    return RdpDataTableEditComponent;
}());

/*
 * ============LICENSE_START==========================================
 * ONAP Portal SDK
 * ===================================================================
 * Copyright © 2019 AT&T Intellectual Property. All rights reserved.
 * ===================================================================
 *
 * Unless otherwise specified, all software contained herein is licensed
 * under the Apache License, Version 2.0 (the "License");
 * you may not use this software except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Unless otherwise specified, all documentation contained herein is licensed
 * under the Creative Commons License, Attribution 4.0 Intl. (the "License");
 * you may not use this documentation except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             https://creativecommons.org/licenses/by/4.0/
 *
 * Unless required by applicable law or agreed to in writing, documentation
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * ============LICENSE_END============================================
 *
 *
 */
var RDPDataSource = /** @class */ (function (_super) {
    __extends(RDPDataSource, _super);
    function RDPDataSource() {
        var _this = _super.call(this) || this;
        _this.dataSubject = new BehaviorSubject([]);
        _this.loadingSubject = new BehaviorSubject(false);
        _this.loading$ = _this.loadingSubject.asObservable();
        return _this;
    }
    RDPDataSource.prototype.loadData = function (applicationService, filter, sortActive, sortDirection, pageIndex, pageSize) {
        var _this = this;
        this.loadingSubject.next(true);
        applicationService.loadTableData(filter, sortActive, sortDirection, pageIndex, pageSize).pipe(catchError(function () { return of([]); }), finalize(function () { return _this.loadingSubject.next(false); }))
            .subscribe(function (data) { return _this.dataSubject.next(data); });
    };
    RDPDataSource.prototype.connect = function (collectionViewer) {
        return this.dataSubject.asObservable();
    };
    RDPDataSource.prototype.disconnect = function (collectionViewer) {
        this.dataSubject.complete();
        this.loadingSubject.complete();
    };
    return RDPDataSource;
}(DataSource));

/*
 * ============LICENSE_START==========================================
 * ONAP Portal SDK
 * ===================================================================
 * Copyright © 2019 AT&T Intellectual Property. All rights reserved.
 * ===================================================================
 *
 * Unless otherwise specified, all software contained herein is licensed
 * under the Apache License, Version 2.0 (the "License");
 * you may not use this software except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Unless otherwise specified, all documentation contained herein is licensed
 * under the Creative Commons License, Attribution 4.0 Intl. (the "License");
 * you may not use this documentation except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             https://creativecommons.org/licenses/by/4.0/
 *
 * Unless required by applicable law or agreed to in writing, documentation
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * ============LICENSE_END============================================
 *
 *
 */
var RdpDataTableComponent = /** @class */ (function () {
    function RdpDataTableComponent(dataTableService, ngbModal) {
        var _this = this;
        this.dataTableService = dataTableService;
        this.ngbModal = ngbModal;
        this.limit = 1000;
        this.full = true;
        this.displayedColumns = [];
        this.columnsInfoList = [];
        this.isPaginationRequired = false;
        this.pageSize = 5;
        this.isServerSidePaginationEnabled = false;
        this.showAddButton = true;
        this.handleScroll = function (scrolled) {
            scrolled ? _this.dataSource : noop();
        };
    }
    RdpDataTableComponent.prototype.ngOnInit = function () {
        if (this.data) {
            this.setData(this.data);
        }
    };
    RdpDataTableComponent.prototype.ngAfterViewInit = function () {
        var _this = this;
        if (this.isServerSidePaginationEnabled) {
            this.sort.sortChange.subscribe(function () { return _this.paginator.pageIndex = 0; });
            fromEvent(this.input.nativeElement, 'keyup')
                .pipe(debounceTime(150), distinctUntilChanged(), tap(function () {
                _this.paginator.pageIndex = 0;
                _this.loadData(_this.paginator.pageIndex, _this.paginator.pageSize);
            })).subscribe();
            merge(this.sort.sortChange, this.paginator.page)
                .pipe(tap(function () { return _this.loadData(_this.paginator.pageIndex, _this.paginator.pageSize); })).subscribe();
        }
        this.dataSource.paginator = this.paginator;
        this.dataSource.sort = this.sort;
    };
    RdpDataTableComponent.prototype.ngOnChanges = function () {
        var _this = this;
        if (this.settings) {
            console.log("Table setting Objects >>>>", this.settings);
            this.applicationService = this.settings.applicationService;
            this.settings.columns.forEach(function (element) {
                _this.displayedColumns.push(element.title);
                _this.columnsInfoList.push(element);
            });
            if (!this.settings.isReadOnly) {
                this.displayedColumns.push('edit');
            }
            if (!this.settings.isReadOnly) {
                this.displayedColumns.push('delete');
            }
            if (this.settings.isReadOnly) {
                this.showAddButton = false;
            }
            if (this.settings.isTableSearchEnabled) {
                this.isSearchEnabled = true;
            }
            if (this.settings.isServerSidePaginationEnabled) {
                this.isServerSidePaginationEnabled = true;
            }
            if (this.settings.isToggleEnabled) {
                this.displayedColumns.push('toggle');
            }
            if (this.settings.isPaginationEnabled) {
                this.isPaginationRequired = true;
                if (this.settings.paginationsSize) {
                    this.pageSize = this.settings.paginationsSize;
                }
            }
            console.log("this.displayedColumns>>>>>", this.displayedColumns);
        }
    };
    RdpDataTableComponent.prototype.setData = function (data) {
        if (this.settings.isServerSidePaginationEnabled) {
            console.log("Server side pagination is enabled");
            this.dataSource = new RDPDataSource();
            this.dataSource.loadData(this.settings.applicationService, '', this.sort.active, this.sort.direction, 0, this.settings.paginationsSize);
            this.totalRowsCount = this.getTotalRowCount();
        }
        else {
            this.dataSource = new MatTableDataSource([]);
            console.log("Server side pagination is not enabled");
            if (Array.isArray(data)) {
                this.dataSource.data = data;
                this.totalRowsCount = data.length;
            }
        }
    };
    RdpDataTableComponent.prototype.getTotalRowCount = function () {
        var totalRows = 0;
        try {
            totalRows = this.settings.applicationService.getTotalRowCount();
        }
        catch (error) {
            console.log("Error while getting total row count :: ", error);
        }
        return totalRows;
    };
    RdpDataTableComponent.prototype.loadData = function (pageIndex, pageSize) {
        this.dataSource = new RDPDataSource();
        this.dataSource.loadData(this.settings.applicationService, this.input.nativeElement.value, this.sort.active, this.sort.direction, pageIndex, pageSize);
    };
    RdpDataTableComponent.prototype.onPaginationChange = function (event) {
        console.log("onPaginationChange event :: ", event);
        //this.loadData(event.pageIndex, event.pageSize);
    };
    RdpDataTableComponent.prototype.addRow = function (data) {
        this.dataTableService.add(this.applicationService, data);
    };
    RdpDataTableComponent.prototype.updateRow = function (data) {
        this.dataTableService.update(this.applicationService, data);
    };
    RdpDataTableComponent.prototype.getRow = function (data) {
        this.dataTableService.get(this.applicationService, data);
    };
    RdpDataTableComponent.prototype.deleteRow = function (data) {
        this.dataTableService.delete(this.applicationService, data);
    };
    RdpDataTableComponent.prototype.applyFilter = function (filterValue) {
        this.dataSource.filter = filterValue.trim().toLowerCase();
    };
    /**
     * openAddNewRoleModal
     * @param rowData
     */
    RdpDataTableComponent.prototype.openEditModalPopup = function (rowData) {
        var _this = this;
        var modalRef = this.ngbModal.open(RdpDataTableEditComponent, { size: 'lg' });
        modalRef.componentInstance.title = 'Edit';
        modalRef.componentInstance.settings = this.settings;
        if (rowData != 'undefined' && rowData) {
            modalRef.componentInstance.rowdata = rowData;
            modalRef.componentInstance.isEditMode = true;
            this.isEditMode = true;
        }
        else {
            modalRef.componentInstance.rowdata = {};
            modalRef.componentInstance.isEditMode = false;
            this.isEditMode = false;
        }
        modalRef.componentInstance.passEntry.subscribe(function (receivedEntry) {
            if (receivedEntry) {
                _this.updateRow(receivedEntry);
                console.log("Entry");
            }
        });
    };
    RdpDataTableComponent.prototype.toggleUserActive = function (rowData) {
        console.log("Row data : ", rowData);
    };
    RdpDataTableComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-data-table',
                    template: "<div>\r\n  <div class=\"table-search-box\">\r\n    <mat-form-field *ngIf=\"isSearchEnabled\">\r\n      <input matInput *ngIf=\"!isServerSidePaginationEnabled\" type=\"text\" (keyup)=\"applyFilter($event.target.value)\" placeholder=\"Search in entire table\">\r\n      <input matInput *ngIf=\"isServerSidePaginationEnabled\"  type=\"text\" #input placeholder=\"Search in entire table\">\r\n    </mat-form-field>\r\n    <button *ngIf=\"showAddButton\" type=\"button\" style=\"float: right;\" class=\"btn btn-primary\" (click)=\"openEditModalPopup('')\">\r\n      <i class=\"icon ion-md-person-add\"></i>&nbsp;Add\r\n    </button>\r\n  </div>\r\n  <!-- <rdp-scroll-container [more]=\"hasMore()\" [scrollOffset]=\"2500\" [scrollDelay]=\"3000\" (scrolled)=\"handleScroll($event)\"\r\n    [class.full]=\"full\" [class.part]=\"!full\"> -->\r\n    <table mat-table #table [dataSource]=\"dataSource\" style=\"width: 100%\" matSort>\r\n      <rdp-column *ngFor=\"let column of columnsInfoList\" name=\"{{column.title}}\"\r\n        label=\"{{column.dispalyTitle | titlecase }}\" sort=\"{{column.sort}}\">\r\n      </rdp-column>\r\n\r\n      <!--Edit column will be displayed only if displayedColumns has Delete-->\r\n      <ng-container matColumnDef=\"edit\">\r\n        <th mat-header-cell *matHeaderCellDef id=\"heading5\">Edit</th>\r\n        <td id=\"rowheader_t1_{{i}}\" mat-cell *matCellDef=\"let rowData; let i=index;\">\r\n          <span class=\"icon-trash\" id=\"{{i}}-button-role-edit\" (click)=\"openEditModalPopup(rowData)\">\r\n            <i class=\"ion ion-md-create\"></i>\r\n          </span>\r\n        </td>\r\n      </ng-container>\r\n      <!--End of Edit Column-->\r\n\r\n      <!--Delete column will be displayed only if displayedColumns has Delete-->\r\n      <ng-container matColumnDef=\"delete\">\r\n        <th mat-header-cell *matHeaderCellDef id=\"heading6\">Delete</th>\r\n        <td id=\"rowheader_t1_{{i}}\" mat-cell *matCellDef=\"let rowData; let i=index;\">\r\n          <span class=\"icon-trash\" id=\"{{i}}-button-role-remove\" (click)=\"deleteRow(rowData)\">\r\n            <i class=\"icon ion-md-trash\"></i>\r\n          </span>\r\n        </td>\r\n      </ng-container>\r\n      <!--End of Delete Column-->\r\n\r\n      <!--Toggle column will be displayed only if displayedColumns has toggle-->\r\n      <ng-container matColumnDef=\"toggle\">\r\n        <th mat-header-cell *matHeaderCellDef id=\"heading6\">Active?</th>\r\n        <td mat-cell *matCellDef=\"let rowData\">\r\n          <mat-slide-toggle [(ngModel)]=\"rowData.active\" (change)=\"toggleUserActive(rowData)\"></mat-slide-toggle>\r\n        </td>\r\n      </ng-container>\r\n      <!--End of Toggle Column-->\r\n\r\n      <tr mat-header-row *matHeaderRowDef=\"displayedColumns\"></tr>\r\n      <tr mat-row *matRowDef=\"let row; columns: displayedColumns;\"></tr>\r\n    </table>\r\n  <!-- </rdp-scroll-container> -->\r\n  <div *ngIf=\"isPaginationRequired\">\r\n    <mat-paginator [length]=\"totalRowsCount\" #paginator [pageSizeOptions]=\"[5, 10, 25, 100]\" [pageSize]=\"pageSize\"\r\n    (page)=\"pageEvent = $event; onPaginationChange($event)\"></mat-paginator>\r\n  </div>\r\n</div>",
                    styles: [".icon-trash{cursor:pointer}.table-search-box{float:right}::ng-deep .table-search-box .mat-form-field-infix{display:block;position:relative;-webkit-box-flex:1;flex:auto;min-width:0;width:340px}:host{-webkit-box-pack:start;justify-content:flex-start;display:-webkit-box;display:flex;-webkit-box-orient:vertical;-webkit-box-direction:normal;flex-direction:column}rdp-scroll-container{-webkit-box-flex:0;flex-grow:0;flex-shrink:0}rdp-scroll-container.full{flex-basis:auto}rdp-scroll-container.part{flex-basis:200px}"]
                }] }
    ];
    /** @nocollapse */
    RdpDataTableComponent.ctorParameters = function () { return [
        { type: RdpDataTableService },
        { type: NgbModal }
    ]; };
    RdpDataTableComponent.propDecorators = {
        data: [{ type: Input }],
        settings: [{ type: Input }],
        sort: [{ type: ViewChild, args: [MatSort,] }],
        paginator: [{ type: ViewChild, args: [MatPaginator,] }],
        table: [{ type: ViewChild, args: [MatTable,] }],
        input: [{ type: ViewChild, args: ['input',] }]
    };
    return RdpDataTableComponent;
}());

/*
 * ============LICENSE_START==========================================
 * ONAP Portal SDK
 * ===================================================================
 * Copyright © 2019 AT&T Intellectual Property. All rights reserved.
 * ===================================================================
 *
 * Unless otherwise specified, all software contained herein is licensed
 * under the Apache License, Version 2.0 (the "License");
 * you may not use this software except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Unless otherwise specified, all documentation contained herein is licensed
 * under the Creative Commons License, Attribution 4.0 Intl. (the "License");
 * you may not use this documentation except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             https://creativecommons.org/licenses/by/4.0/
 *
 * Unless required by applicable law or agreed to in writing, documentation
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * ============LICENSE_END============================================
 *
 *
 */
var RdpColumnComponent = /** @class */ (function () {
    function RdpColumnComponent(table) {
        this.table = table;
    }
    Object.defineProperty(RdpColumnComponent.prototype, "name", {
        // @ContentChild(TemplateRef) template: TemplateRef<any>;
        // @ContentChild('colContent') colContentTmpl: TemplateRef<any>;
        /** Column name that should be used to reference this column. */
        get: function () { return this._name; },
        set: function (name) {
            this._name = name;
            this.columnDef.name = name;
        },
        enumerable: true,
        configurable: true
    });
    RdpColumnComponent.prototype.ngOnInit = function () {
        if (this.table) {
            //console.log("Column name --"+this._name+ " Is Sorting  applied  ",this.sort);
            this._sortable = coerceBooleanProperty(this.sort);
            //console.log("this._sortable ",this._sortable);
            if (this._name === 'delete' || this._name === 'edit') ;
            else {
                this.table.addColumnDef(this.columnDef);
            }
        }
    };
    RdpColumnComponent.prototype.ngOnDestroy = function () {
        if (this.table) {
            this.table.removeColumnDef(this.columnDef);
        }
    };
    RdpColumnComponent.prototype.getData = function (data) {
        return this.dataAccessor ? this.dataAccessor(data, this.name) : data[this.name];
    };
    RdpColumnComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-column',
                    template: "\n  <ng-container matColumnDef>\n      <div *ngIf=\"_sortable\">\n       <th mat-header-cell *matHeaderCellDef mat-sort-header> {{ label }} </th>\n      </div>\n      <div *ngIf=\"!_sortable\">\n          <th mat-header-cell *matHeaderCellDef> {{ label }} </th>\n      </div>\n      <td mat-cell *matCellDef=\"let data\" id=\"{{ label }}\">\n          {{ getData(data) }}\n      </td>\n  </ng-container>"
                }] }
    ];
    /** @nocollapse */
    RdpColumnComponent.ctorParameters = function () { return [
        { type: MatTable, decorators: [{ type: Optional }] }
    ]; };
    RdpColumnComponent.propDecorators = {
        name: [{ type: Input }],
        label: [{ type: Input }],
        sort: [{ type: Input }],
        dataAccessor: [{ type: Input }],
        columnDef: [{ type: ViewChild, args: [MatColumnDef,] }],
        sortHeader: [{ type: ViewChild, args: [MatSortHeader,] }]
    };
    return RdpColumnComponent;
}());

var RdpInputEditorComponent = /** @class */ (function () {
    function RdpInputEditorComponent() {
        this.changedColumnValue = new EventEmitter();
    }
    RdpInputEditorComponent.prototype.ngOnInit = function () {
        if (this.rowdata != null || this.rowdata != undefined) {
            var rowObj = JSON.parse(this.rowdata);
            var column = this.columntitle;
            this.columnValue = rowObj[column];
        }
        else {
            this.columnValue = null;
        }
        this.isColumnDisabled = this.disabled;
    };
    RdpInputEditorComponent.prototype.detectChange = function (changedValue) {
        this.changedColumnValue.emit(changedValue);
    };
    RdpInputEditorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-input-editor',
                    template: "\n      <input class=\"input-editor\" [disabled]=\"isColumnDisabled\"  \n      [(ngModel)]=\"columnValue\" \n      type=\"text\" name=\"{{columntitle}}\"  \n      id=\"{{columntitle}}\"\n      (change)=\"detectChange(columnValue)\">\n  ",
                    styles: [".input-editor{width:31em}"]
                }] }
    ];
    /** @nocollapse */
    RdpInputEditorComponent.ctorParameters = function () { return []; };
    RdpInputEditorComponent.propDecorators = {
        rowdata: [{ type: Input }],
        columntitle: [{ type: Input }],
        disabled: [{ type: Input }],
        changedColumnValue: [{ type: Output }]
    };
    return RdpInputEditorComponent;
}());

var ScrollDirection;
(function (ScrollDirection) {
    ScrollDirection["UP"] = "up";
    ScrollDirection["DOWN"] = "down";
})(ScrollDirection || (ScrollDirection = {}));
var ScrollListener;
(function (ScrollListener) {
    ScrollListener["HOST"] = "scroll";
    ScrollListener["WINDOW"] = "window:scroll";
})(ScrollListener || (ScrollListener = {}));
var RdpScrollContainerComponent = /** @class */ (function () {
    function RdpScrollContainerComponent(elRef) {
        var _this = this;
        this.elRef = elRef;
        this.scrollTop = 0;
        this.more = true;
        this.scrollDelay = 500;
        this.scrollOffset = 1000;
        this.scrolled = new EventEmitter();
        this.getListener = function () { return _this.elRef.nativeElement.clientHeight === _this.elRef.nativeElement.scrollHeight
            ? ScrollListener.WINDOW
            : ScrollListener.HOST; };
        this.roundTo = function (from, to) {
            if (to === void 0) { to = _this.scrollOffset; }
            return Math.floor(from / to) * to;
        };
        this.getScrollDirection = function (st) { return _this.scrollTop <= st ? ScrollDirection.DOWN : ScrollDirection.UP; };
        this.handleScroll = function () { return _this.getListener() === ScrollListener.HOST
            ? _this.scrolled.emit(_this.canScroll(_this._element))
            : _this.scrolled.emit(_this.canScroll(_this._window)); };
        this._element = this.elRef.nativeElement;
        this._window = document.documentElement;
    }
    RdpScrollContainerComponent.prototype.ngOnInit = function () {
        this.setThrottle();
    };
    RdpScrollContainerComponent.prototype.ngOnChanges = function (changes) {
        if (changes.scrollDelay)
            this.setThrottle();
    };
    RdpScrollContainerComponent.prototype.setThrottle = function () {
        this._scroll = this._windowScroll = throttle(this.handleScroll, this.scrollDelay);
    };
    RdpScrollContainerComponent.prototype.canScroll = function (e) {
        var scrolled = this.more
            && this.getScrollDirection(e.scrollTop) === ScrollDirection.DOWN
            && this.roundTo(e.clientHeight) === this.roundTo(e.scrollHeight - e.scrollTop);
        this.scrollTop = e.scrollTop;
        return scrolled;
    };
    RdpScrollContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-scroll-container',
                    template: "<ng-content></ng-content>",
                    styles: [":host{overflow:auto}"]
                }] }
    ];
    /** @nocollapse */
    RdpScrollContainerComponent.ctorParameters = function () { return [
        { type: ElementRef }
    ]; };
    RdpScrollContainerComponent.propDecorators = {
        more: [{ type: Input }],
        scrollDelay: [{ type: Input }],
        scrollOffset: [{ type: Input }],
        scrolled: [{ type: Output }],
        _scroll: [{ type: HostListener, args: [ScrollListener.HOST,] }],
        _windowScroll: [{ type: HostListener, args: [ScrollListener.WINDOW,] }]
    };
    return RdpScrollContainerComponent;
}());

/*-
 * ============LICENSE_START==========================================
 * ONAP Portal-SDK
 * ===================================================================
 * Copyright (C) 2017 AT&T Intellectual Property. All rights reserved.
 * ===================================================================
 *
 * Unless otherwise specified, all software contained herein is licensed
 * under the Apache License, Version 2.0 (the "License");
 * you may not use this software except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Unless otherwise specified, all documentation contained herein is licensed
 * under the Creative Commons License, Attribution 4.0 Intl. (the "License");
 * you may not use this documentation except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             https://creativecommons.org/licenses/by/4.0/
 *
 * Unless required by applicable law or agreed to in writing, documentation
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * ============LICENSE_END============================================
 *
 *
 */
var Column = /** @class */ (function () {
    function Column(title, dispalyTitle, type, sort, listData) {
        this.listData = [];
        this.title = title;
        this.dispalyTitle = dispalyTitle;
        this.type = type;
        this.sort = sort;
        this.isColumnDisabled = false;
        this.listData = listData;
    }
    Object.defineProperty(Column.prototype, "setIsColumnDisabled", {
        set: function (value) {
            this.isColumnDisabled = value;
        },
        enumerable: true,
        configurable: true
    });
    return Column;
}());
var ColumnTypes;
(function (ColumnTypes) {
    ColumnTypes["DROPDOWN"] = "dropdown";
    ColumnTypes["TEXT"] = "text";
    ColumnTypes["RADIO"] = "radio";
    ColumnTypes["CHECKBOX"] = "checkbox";
    ColumnTypes["TEXTAREA"] = "textarea";
    ColumnTypes["DATE_PICKER"] = "datepicker";
})(ColumnTypes || (ColumnTypes = {}));

/*-
 * ============LICENSE_START==========================================
 * ONAP Portal-SDK
 * ===================================================================
 * Copyright (C) 2017 AT&T Intellectual Property. All rights reserved.
 * ===================================================================
 *
 * Unless otherwise specified, all software contained herein is licensed
 * under the Apache License, Version 2.0 (the "License");
 * you may not use this software except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * Unless otherwise specified, all documentation contained herein is licensed
 * under the Creative Commons License, Attribution 4.0 Intl. (the "License");
 * you may not use this documentation except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *             https://creativecommons.org/licenses/by/4.0/
 *
 * Unless required by applicable law or agreed to in writing, documentation
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * ============LICENSE_END============================================
 *
 *
 */
var DataTableSettings = /** @class */ (function () {
    function DataTableSettings() {
        this._columns = [];
        this._paginationsSize = "10";
        this._isPaginationEnabled = true;
        this._isReadOnly = false;
        this._isTableSearchEnabled = true;
        this._toggleEnabled = false;
    }
    Object.defineProperty(DataTableSettings.prototype, "columns", {
        get: function () {
            return this._columns;
        },
        set: function (value) {
            this._columns = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableSettings.prototype, "isPaginationEnabled", {
        get: function () {
            return this._isPaginationEnabled;
        },
        set: function (value) {
            this._isPaginationEnabled = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableSettings.prototype, "paginationsSize", {
        get: function () {
            return this._paginationsSize;
        },
        set: function (value) {
            this._paginationsSize = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableSettings.prototype, "isReadOnly", {
        get: function () {
            return this._isReadOnly;
        },
        set: function (value) {
            this._isReadOnly = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableSettings.prototype, "isServerSidePaginationEnabled", {
        get: function () {
            return this._isServerSidePaginationEnabled;
        },
        set: function (value) {
            this._isServerSidePaginationEnabled = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableSettings.prototype, "isServerSideSortingEnabled", {
        get: function () {
            return this._isServerSideSortingEnabled;
        },
        set: function (value) {
            this._isServerSideSortingEnabled = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableSettings.prototype, "isTableSearchEnabled", {
        get: function () {
            return this._isTableSearchEnabled;
        },
        set: function (value) {
            this._isTableSearchEnabled = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableSettings.prototype, "isToggleEnabled", {
        get: function () {
            return this._toggleEnabled;
        },
        set: function (value) {
            this._toggleEnabled = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableSettings.prototype, "applicationService", {
        get: function () {
            return this._applicationService;
        },
        set: function (value) {
            this._applicationService = value;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(DataTableSettings.prototype, "modalPopupTitle", {
        get: function () {
            return this._modalPopupTitle;
        },
        set: function (value) {
            this._modalPopupTitle = value;
        },
        enumerable: true,
        configurable: true
    });
    return DataTableSettings;
}());

var MaterialModule = /** @class */ (function () {
    function MaterialModule() {
    }
    MaterialModule.decorators = [
        { type: NgModule, args: [{
                    exports: [
                        A11yModule,
                        CdkStepperModule,
                        CdkTableModule,
                        CdkTreeModule,
                        DragDropModule,
                        MatAutocompleteModule,
                        MatBadgeModule,
                        MatBottomSheetModule,
                        MatButtonModule,
                        MatButtonToggleModule,
                        MatCardModule,
                        MatCheckboxModule,
                        MatChipsModule,
                        MatStepperModule,
                        MatDatepickerModule,
                        MatDialogModule,
                        MatDividerModule,
                        MatExpansionModule,
                        MatFormFieldModule,
                        MatGridListModule,
                        MatIconModule,
                        MatInputModule,
                        MatListModule,
                        MatMenuModule,
                        MatNativeDateModule,
                        MatPaginatorModule,
                        MatProgressBarModule,
                        MatProgressSpinnerModule,
                        MatRadioModule,
                        MatRippleModule,
                        MatSelectModule,
                        MatSidenavModule,
                        MatSliderModule,
                        MatSlideToggleModule,
                        MatSnackBarModule,
                        MatSortModule,
                        MatTableModule,
                        MatTabsModule,
                        MatToolbarModule,
                        MatTooltipModule,
                        MatTreeModule,
                        PortalModule,
                        ScrollingModule,
                    ]
                },] }
    ];
    return MaterialModule;
}());
/**  Copyright 2019 Google Inc. All Rights Reserved.
    Use of this source code is governed by an MIT-style license that
    can be found in the LICENSE file at http://angular.io/license */

var RdpSelectEditorComponent = /** @class */ (function () {
    function RdpSelectEditorComponent() {
        this.changedColumnValue = new EventEmitter();
    }
    RdpSelectEditorComponent.prototype.ngOnInit = function () {
        if (this.rowdata != null || this.rowdata != undefined) {
            var rowObj = JSON.parse(this.rowdata);
            var column = this.columntitle;
            this.columnValue = rowObj[column];
        }
        else {
            this.columnValue = null;
        }
        this.selected = this.columnValue;
    };
    RdpSelectEditorComponent.prototype.detectChange = function (changedValue) {
        this.changedColumnValue.emit(changedValue.name);
    };
    RdpSelectEditorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-select-editor',
                    template: "\n    <mat-select name=\"{{columntitle}}\" [(ngModel)]=\"columnValue\" [(value)]=\"selected\" \n    (selectionChange)=\"detectChange(columnValue)\">\n      <mat-option *ngFor=\"let item of data\" [value]=\"item\">\n      {{item.name}}\n      </mat-option>\n    </mat-select>\n  ",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    RdpSelectEditorComponent.ctorParameters = function () { return []; };
    RdpSelectEditorComponent.propDecorators = {
        rowdata: [{ type: Input }],
        columntitle: [{ type: Input }],
        data: [{ type: Input }],
        changedColumnValue: [{ type: Output }]
    };
    return RdpSelectEditorComponent;
}());

var RdpTextareaEditorComponent = /** @class */ (function () {
    function RdpTextareaEditorComponent() {
    }
    RdpTextareaEditorComponent.prototype.ngOnInit = function () {
        console.log("RdpTextareaEditorComponent Row Data ::: ", this.rowdata);
        var rowObj = JSON.parse(this.rowdata);
        var column = this.columntitle;
        this.columnValue = rowObj[column];
    };
    RdpTextareaEditorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-textarea-editor',
                    template: "\n    <textarea style=\"border:solid 1px;\" \n        [(ngModel)]=\"columnValue\" matInput placeholder=\"Textarea\">\n    </textarea>\n  ",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    RdpTextareaEditorComponent.ctorParameters = function () { return []; };
    RdpTextareaEditorComponent.propDecorators = {
        rowdata: [{ type: Input }],
        columntitle: [{ type: Input }]
    };
    return RdpTextareaEditorComponent;
}());

var RdpCheckboxEditorComponent = /** @class */ (function () {
    function RdpCheckboxEditorComponent() {
    }
    RdpCheckboxEditorComponent.prototype.ngOnInit = function () {
        console.log("RdpCheckboxEditorComponent Row Data ::: ", this.rowdata);
        var rowObj = JSON.parse(this.rowdata);
        var column = this.columntitle;
        this.columnValue = rowObj[column];
    };
    RdpCheckboxEditorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-checkbox-editor',
                    template: "\n  <div id=\"property-active\" class=\"property-active\">\n    <mat-checkbox name=\"isEnabled\" [(ngModel)]=\"columnValue\" [checked]=\"columnValue\">{{columntitle}}\n    </mat-checkbox>\n  </div>\n  ",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    RdpCheckboxEditorComponent.ctorParameters = function () { return []; };
    RdpCheckboxEditorComponent.propDecorators = {
        rowdata: [{ type: Input }],
        columntitle: [{ type: Input }]
    };
    return RdpCheckboxEditorComponent;
}());

var RdpDatepickerEditorComponent = /** @class */ (function () {
    function RdpDatepickerEditorComponent() {
    }
    RdpDatepickerEditorComponent.prototype.ngOnInit = function () {
        console.log("RdpDatepickerEditorComponent Row Data ::: ", this.rowdata);
        var rowObj = JSON.parse(this.rowdata);
        var column = this.columntitle;
        this.columnValue = rowObj[column];
    };
    RdpDatepickerEditorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-datepicker-editor',
                    template: "\n  <mat-form-field>\n    <input [(ngModel)]=\"columnValue\" name=\"{{columntitle}}\" matInput [matDatepicker]=\"date\" \n      placeholder=\"MM/dd/yyyy\">\n    <mat-datepicker-toggle matSuffix [for]=\"date\"></mat-datepicker-toggle>\n    <mat-datepicker #date></mat-datepicker>\n  </mat-form-field>\n  ",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    RdpDatepickerEditorComponent.ctorParameters = function () { return []; };
    RdpDatepickerEditorComponent.propDecorators = {
        rowdata: [{ type: Input }],
        columntitle: [{ type: Input }]
    };
    return RdpDatepickerEditorComponent;
}());

var RdpAutocompleteEditorComponent = /** @class */ (function () {
    function RdpAutocompleteEditorComponent() {
    }
    RdpAutocompleteEditorComponent.prototype.ngOnInit = function () {
    };
    RdpAutocompleteEditorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-rdp-autocomplete-editor',
                    template: "<p>\n  rdp-autocomplete-editor works!\n</p>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    RdpAutocompleteEditorComponent.ctorParameters = function () { return []; };
    return RdpAutocompleteEditorComponent;
}());

var RdpRadioEditorComponent = /** @class */ (function () {
    function RdpRadioEditorComponent() {
    }
    RdpRadioEditorComponent.prototype.ngOnInit = function () {
    };
    RdpRadioEditorComponent.decorators = [
        { type: Component, args: [{
                    selector: 'rdp-radio-editor',
                    template: "<p>\n  rdp-radio-editor works!\n</p>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    RdpRadioEditorComponent.ctorParameters = function () { return []; };
    RdpRadioEditorComponent.propDecorators = {
        rowdata: [{ type: Input }],
        columntitle: [{ type: Input }]
    };
    return RdpRadioEditorComponent;
}());

var RdpModule = /** @class */ (function () {
    function RdpModule() {
    }
    RdpModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        RdpDataTableComponent,
                        RdpColumnComponent,
                        RdpDataTableEditComponent,
                        RdpInputEditorComponent,
                        RdpSelectEditorComponent,
                        RdpTextareaEditorComponent,
                        RdpCheckboxEditorComponent,
                        RdpRadioEditorComponent,
                        RdpDatepickerEditorComponent,
                        RdpAutocompleteEditorComponent,
                        RdpScrollContainerComponent
                    ],
                    imports: [
                        CommonModule,
                        MaterialModule,
                        HttpClientModule,
                        ReactiveFormsModule,
                        FormsModule,
                        NgbModule
                    ],
                    exports: [
                        RdpDataTableComponent,
                        RdpColumnComponent,
                        RdpInputEditorComponent,
                        RdpSelectEditorComponent,
                        RdpTextareaEditorComponent,
                        RdpCheckboxEditorComponent,
                        RdpRadioEditorComponent,
                        RdpDatepickerEditorComponent,
                        RdpAutocompleteEditorComponent,
                        RdpScrollContainerComponent
                    ],
                    entryComponents: [RdpDataTableEditComponent],
                    providers: [RdpDataTableService]
                },] }
    ];
    return RdpModule;
}());

/*
 * Public API Surface of portalsdk-tag-lib
 */

/**
 * Generated bundle index. Do not edit.
 */

export { RdpAutocompleteEditorComponent as ɵg, RdpCheckboxEditorComponent as ɵd, RdpDatepickerEditorComponent as ɵf, RdpRadioEditorComponent as ɵe, RdpSelectEditorComponent as ɵb, RdpTextareaEditorComponent as ɵc, RdpDataTableEditComponent as ɵa, MaterialModule as ɵh, PortalsdkTagLibService, PortalsdkTagLibComponent, PortalsdkTagLibModule, RdpDataTableService, RdpDataTableComponent, RdpColumnComponent, RdpInputEditorComponent, RdpScrollContainerComponent, Column, ColumnTypes, DataTableSettings, RdpModule };

//# sourceMappingURL=portalsdk-tag-lib.js.map