import { OnDestroy, OnInit } from '@angular/core';
import { MatSortHeader } from '@angular/material';
import { MatColumnDef, MatTable } from '@angular/material';
export declare class RdpColumnComponent<T> implements OnDestroy, OnInit {
    table: MatTable<any>;
    /** Column name that should be used to reference this column. */
    name: string;
    _name: string;
    /**
     * Text label that should be used for the column header. If this property is not
     * set, the header text will default to the column name.
     */
    label: string;
    /**
    * Text label that should be used for the column header. If this property is not
    * set, the header text will default to the column name.
    */
    sort: boolean;
    /**
     * Accessor function to retrieve the data should be provided to the cell. If this
     * property is not set, the data cells will assume that the column name is the same
     * as the data property the cells should display.
     */
    dataAccessor: ((data: T, name: string) => string);
    columnDef: MatColumnDef;
    sortHeader: MatSortHeader;
    constructor(table: MatTable<any>);
    _sortable: boolean;
    ngOnInit(): void;
    ngOnDestroy(): void;
    getData(data: T): any;
}
